import { CrudOptions } from './Reference.js';
import Transform from './Transform.js';
import { FirebaseDocument, FirebaseMap } from './Document.js';
import Database from './Database.js';
/** Trims spaces and slashes from a path */
export declare function trimPath(path: string): string;
/** Returns true if a variable is a path that points to a document */
export declare function isDocPath(s: any): boolean;
/** Returns true if an object is a "raw" firebase document */
export declare function isRawDocument(document: any): boolean;
/** Checks if a value is a Reference to a Document */
export declare function isDocReference(val: any): boolean;
/** Returns true if a value is a Reference to a Collection */
export declare function isColReference(val: any): boolean;
/** Checks if a value is a number that is not negative and is an integer */
export declare function isPositiveInteger(val: any): boolean;
/** Converts an Object to a URI query String */
export declare function objectToQuery(obj?: any, parentProp?: string): string;
/** Returns an array of keyPaths of an object but skips over arrays values */
export declare function getKeyPaths(object: any, parentPath?: string): string[];
/** compile options object into firebase valid api arguments object */
export declare function compileOptions(options: CrudOptions, obj: any): any;
/** Decodes a map into a JS object */
export declare function decode(map: FirebaseMap | FirebaseDocument, db: Database): any;
/** Encodes a JS variable into a Firebase Value */
export declare function encodeValue(value: any, transforms?: Transform[], parentPath?: string): any;
/** Converts an object into a write instruction */
export declare function encode(object: any, transforms?: Transform[], parentPath?: string): FirebaseMap;
/** Generates 22 chars long random alphanumerics unique identifiers */
export declare function fid(): string;
